
#include <LittleRobotFriends.h>

int x;
unsigned long nextTime = 0;
boolean candleState = false; // To turn on and off the flicker effect. It starts as off

LRFSong happyBirthday = {
  .length = 19,
  .octaveShift = 0,
  .pattern = { LRFColor_Red, LRFColor_Red, LRFTransform_Random, LRFDuration_DoubleLong },
  .sounds = {
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_D, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_F, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_E, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Long, LRFDuration_Medium   },
  
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_D, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_G, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_F, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Long, LRFDuration_Medium   },
  
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_C, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_C, LRFOctave_5, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_A, LRFOctave_5, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_F, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_E, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_D, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Long, LRFDuration_None   }
  }
};

LRFSong hooray = {
  .length = 7,
  .octaveShift = 0,
  .pattern = { LRFColor_Orange, LRFColor_Yellow, LRFTransform_Flip, LRFDuration_DoubleLong },
  .sounds = {
    { LRFNote_AS, LRFOctave_5, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_AS, LRFOctave_5, LRFIntonation_Flat, LRFDuration_Medium, LRFDuration_Short   },
    { LRFNote_A, LRFOctave_5, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_F, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_G, LRFOctave_4, LRFIntonation_Flat, LRFDuration_DoubleMedium, LRFDuration_Short   },
    { LRFNote_F, LRFOctave_4, LRFIntonation_Flat, LRFDuration_Long, LRFDuration_None   },
    { LRFNote_F, LRFOctave_4, LRFIntonation_Rising, LRFDuration_DoubleLong, LRFDuration_Long   }
  }
};

// Function to play song and turn on the LED pattern and start the flicker effect
void candleOn(LRFEvent event) 
{
  lrf.sing(&happyBirthday);
  lrf.sing(&hooray);
  
  candleState = true;
}

void candleUpdate(void) 
{
  lrf.eyes.set(64, x, 0);
}

void candleOff(LRFEvent event) 
{
  candleState = false;
  lrf.eyes.set(0, 0, 0);
}

void setup(void) 
{
  lrf.setup();
  lrf.setBoredomTimer(0);
  lrf.disableEventExpressions();
  lrf.setEventHandler(LRFEvent_RobotIsSleeping, NULL);
  
  lrf.setEventHandler(LRFEvent_Hug, &candleOn); // To turn on the candle effect you 'hug' the LRF
  lrf.setEventHandler(LRFEvent_SoundTooLoud, &candleOff); // To turn off the candle effect you talk or blow into the mic
}

void loop(void) 
{
  lrf.loop();

  // Make the flicker effect
  if(candleState == true && millis() > nextTime) 
  {
    nextTime = millis() + 100;

    x = random(30, 64); // This will make x run between the numbers 30 to 64

    candleUpdate();
  }  
}


